// listing of all the hresults for qvsrpam terminal object etc.

#define ERR_BASE 0x6000
 
enum HResults {
   errNoUnitID                      = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    1),
   errUserTermNumMode               = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    2),
   errNoTermNumAvailable            = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    3),
   errMissingTermNum                = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    4),
   errMaxTermsExceeded              = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    5),
   errBadDeviceID                   = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    6),
   errCantConfigureAuto             = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    7),
   errNoInstanceData                = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    8),
   errCantSetTermNum                = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +    9),
   errNoFileName                    = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   10),
   err4690Error                     = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   11),
   errNoPrintBuffering              = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   12),
   errBadPropertyValue              = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   13),
   errBadMode                       = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   14),
   errKeyboardBuffFull              = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   15),
   wrn4690Error                     = MAKE_HRESULT(SEVERITY_SUCCESS, FACILITY_ITF, ERR_BASE   +   1),
   errCantConfigureDevice           = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   16),
   errNotConnected                  = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   17),
   errMaxWriteLenExceeded           = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   18),
   errNotImplemented                = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   19),
   errMSRDataTooBig                 = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   20),
   errInvalidPrsPipeID              = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   21),
   errInvalidPrsDestNode            = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   22),
   errReadTimedOut                  = MAKE_HRESULT(SEVERITY_ERROR,   FACILITY_ITF, ERR_BASE   +   23),
   };
