// vcsampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "afxctl.h"
#include "vcsample.h"
#include "vcsampleDlg.h"
#include "process.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcsampleDlg dialog

CVcsampleDlg::CVcsampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVcsampleDlg::IDD, pParent)
{
   int ppi;
   CWindowDC dc(NULL);
      
	//{{AFX_DATA_INIT(CVcsampleDlg)
	m_Connect = FALSE;
	m_UnitID = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
   m_UnitID = _T("1");
   EnableAutomation();

   m_Online = 0;
   ppi = dc.GetDeviceCaps(LOGPIXELSY);
   ppi = (ppi * 10)/72;
   
   // create a fixed font
   m_PrintFont.CreateFont(ppi, 0, 0, 0, FW_NORMAL, 0,0,0,
		     DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
		     CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		     FF_MODERN, "Courier New");

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcsampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVcsampleDlg)
	DDX_Control(pDX, IDC_CRPRINTER, m_CRPrinter);
	DDX_Control(pDX, IDC_ROW2, m_Row2);
	DDX_Control(pDX, IDC_ROW1, m_Row1);
	DDX_Check(pDX, IDC_CONNECT, m_Connect);
	DDX_Text(pDX, IDC_UNITID, m_UnitID);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVcsampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVcsampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STARTTERM, OnStartterm)
	ON_BN_CLICKED(IDC_FILEOP, OnFileop)
	//}}AFX_MSG_MAP
   ON_CONTROL_RANGE(BN_CLICKED, IDC_7, IDC_ENTER, OnBtnClicked)
   ON_MESSAGE(WM_PRINT_EVENT, OnPrintEvent)
   ON_MESSAGE(WM_ONLINE_EVENT, OnOnlineEvent)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CVcsampleDlg, CDialog)
   DISP_FUNCTION_ID(CVcsampleDlg,"OnlineEvent",1,OnOnlineEvent,VT_EMPTY,VTS_NONE)
   DISP_FUNCTION_ID(CVcsampleDlg,"DisplayEvent",101,OnDisplayEvent,VT_EMPTY,VTS_I4 VTS_BSTR VTS_BSTR)
   DISP_FUNCTION_ID(CVcsampleDlg,"PrintEvent",201, OnPrintEvent,VT_EMPTY,VTS_I4 VTS_BSTR VTS_I4)
END_DISPATCH_MAP()

// Note: we add support for IID_IDispEvts to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .ODL file.

extern "C" const IID DIID__IQVSRPAMEvents;
extern "C" const CLSID CLSID_POSFile;
extern "C" const CLSID CLSID_POSKeyedFile;

BEGIN_INTERFACE_MAP(CVcsampleDlg, CDialog)
        INTERFACE_PART(CVcsampleDlg, DIID__IQVSRPAMEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcsampleDlg message handlers
BOOL CVcsampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

   App.CreateDispatch("QVSRPAM.RPAMApp");
   App.SetTermNumAssignMode(1);
   //App.SetEventMode(1);

   // Start using the rpam terminal object
   Term.CreateDispatch("QVSRPAM.RPAMTerminal");

   // hook up to receive events
   LPUNKNOWN pUnkSink = GetIDispatch(FALSE);
   LPUNKNOWN pUnkSrc;

   Term.m_lpDispatch->QueryInterface(IID_IUnknown, (void **)(&pUnkSrc));
   AfxConnectionAdvise(pUnkSrc, DIID__IQVSRPAMEvents, pUnkSink, FALSE, &DispEvtsCookie);
                          
   Display = Term.GetANDisplay();
   IOProc = Term.GetIOProcessor();
   Printer = Term.GetPrinter();

   m_CRPrinter.SetFont(&m_PrintFont);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcsampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcsampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcsampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVcsampleDlg::OnStartterm() 
{
   UpdateData();

   long lUnitID = atol((const char *)(m_UnitID));

   Term.SetUnitID(lUnitID);
   Term.SetTermNum(lUnitID);

   m_Row1.UpdateData(Display.GetRow1Text());
   m_Row2.UpdateData(Display.GetRow2Text());

   if (m_Connect)
      Term.Connect();
}

void CVcsampleDlg::OnBtnClicked(UINT nID)
   {
   long FCode;
   switch(nID)
      {
      case IDC_0              : FCode = 48; break;
      case IDC_1              : FCode = 49; break;
      case IDC_2              : FCode = 50; break;
      case IDC_3              : FCode = 51; break;
      case IDC_4              : FCode = 52; break;
      case IDC_5              : FCode = 53; break;
      case IDC_6              : FCode = 54; break;
      case IDC_7              : FCode = 55; break;
      case IDC_8              : FCode = 56; break;
      case IDC_9              : FCode = 57; break;
      case IDC_SLASH          : FCode = 78; break;
      case IDC_CASH           : FCode = 91; break;
      case IDC_SIGNON         : FCode = 61; break;
      case IDC_CLEAR          : FCode = 73; break;
      case IDC_TOTAL          : FCode = 81; break;
      case IDC_ENTER          : FCode = 80; break;
      default:
         return;
      }
      IOProc.SendKeyboardData(FCode);
   }



// example of using POSFile and POSKeyedFile objects
void CVcsampleDlg::OnFileop() 
   {
   IPOSFile PFile;
   IPOSKeyedFile PKFile;
   BOOL rc;
   VARIANT v;
   int x;
   char *DataPtr;
   long BytesRead;

	if (!m_Online)
      {
      AfxMessageBox("Can't do file ops until terminal is online!");
      }
   else
      {
      // do some sequential file operations
      rc = PFile.CreateDispatch(CLSID_POSFile);
      if (rc)
         {
         // set the unit ID and name
         // unit ID must match unit ID of the terminal you want to 
         // use
         PFile.SetUnitID(atol((const char *)(m_UnitID)));
         PFile.SetName("R::ADX_UDT1\\FILEOP.DAT");

         // create the file with read/write/delete permissions
         PFile.Create(rpaFlgDelete + rpaFlgWrite + rpaFlgRead   , 0x400, 0L, 0L);

         // prepare a variant SAFEARRAY to use in the transfer
         VariantInit(&v);
         v.parray = SafeArrayCreateVector(VT_UI1, 0, 25);
         v.vt = VT_ARRAY | VT_UI1;

         if (PFile.GetErrorCode4690() == 0)
            {
            // now write some data to the file

            for (x=0;x<20;x++)
               {
               SafeArrayAccessData(v.parray, (void **)&DataPtr);
               memset(DataPtr, x+0x30, 25);
               SafeArrayUnaccessData(v.parray);
               // we need to use the new Write2 method because MFC can't
               // handle SAFEARRAYs of (uchar *) elements
               PFile.Write2(rpaSeekFP, &v, 25, 0);
               }
            PFile.Close();
            }
         // now read in a couple of buffers from the file
         PFile.Open(rpaFlgRead, 0L);
         if (PFile.GetErrorCode4690() == 0)
            {
            // read 25 bytes from offset 35
            // we need to use the new Read2 method because MFC can't
            // handle SAFEARRAYs of (uchar *) elements
            VariantInit(&v);
            v.parray = SafeArrayCreateVector(VT_UI1, 0, 25);
            V_VT(&v) = VT_ARRAY | VT_UI1;           
            PFile.Read2(rpaSeekBOF, &v, 25, 35, &BytesRead);
            // get access to the read in data
            SafeArrayAccessData(v.parray, (void **)&DataPtr);
            // do things with DataPtr

            // release access to our data
            SafeArrayUnaccessData(v.parray);

            // read 12 bytes from offset 47
            // we need to use the new Read2 method because MFC can't
            // handle SAFEARRAYs of (uchar *) elements
            VariantInit(&v);
            PFile.Read2(rpaSeekBOF, &v, 12, 47, &BytesRead);
            // get access to the read in data
            SafeArrayAccessData(v.parray, (void **)&DataPtr);
            // do things with DataPtr

            // release access to our data
            SafeArrayUnaccessData(v.parray);
            }
         }

      // do some keyed file operations
      rc = PKFile.CreateDispatch(CLSID_POSKeyedFile);
      if (rc)
         {
         // set the unit ID and name
         // unit ID must match unit ID of the terminal you want to 
         // use
         PKFile.SetUnitID(atol((const char *)(m_UnitID)));
         PKFile.SetName("R::ADX_UDT1\\KEYED.FIL");

         // open the file with read/write permissions
         PKFile.Open(rpaFlgWrite + rpaFlgRead   , 0L);

         // write a record with key value 'KEY02' to the file
         // the sample keyed file 'KEYED.FIL' has record length
         // of 20 with a key length of 5
         VariantInit(&v);
         v.parray = SafeArrayCreateVector(VT_UI1, 0, 20);
         v.vt = VT_ARRAY | VT_UI1;

         // access the data and fill in our record
         SafeArrayAccessData(v.parray, (void **)&DataPtr);
         memcpy(DataPtr, "KEY02X_____________Y", 20);
         SafeArrayUnaccessData(v.parray);

         PKFile.Write2(0, &v, 20);

         // now read in the record with key value 'KEY01'
         // this record already exists in the sample keyed
         // file 'KEYED.FIL'
         SafeArrayAccessData(v.parray, (void **)&DataPtr);
         // we put the key value into the buffer for a read
         memcpy(DataPtr, "KEY01", 5);
         SafeArrayUnaccessData(v.parray);

         // read the data
         PKFile.Read2(0, &v, 20, 5);


         // get access to the returned buffer
         SafeArrayAccessData(v.parray, (void **)&DataPtr);
         // do things with DataPtr
         SafeArrayUnaccessData(v.parray);

         // close the file
         PKFile.Close(0);
         }

      }
   }

void CVcsampleDlg::OnPrintEvent(long Station, LPCTSTR PrintLine, long LineFeeds)
   {
   if (Station == 6)
      {
      m_CRPrinter.AddString(PrintLine);
      while (LineFeeds-- > 1)
         {
         m_CRPrinter.AddString("");
         }
      UpdateData(FALSE);
      m_CRPrinter.SetCurSel(m_CRPrinter.GetCount()-1);
      }

   }

void CVcsampleDlg::OnOnlineEvent()
   {
   m_Online = 1;
   }

void CVcsampleDlg::OnDisplayEvent(LONG Device, LPCTSTR Row1Text, LPCTSTR Row2Text)
   {
   if (Device == 0)
      {
      m_Row1.UpdateData(Row1Text);
      m_Row2.UpdateData(Row2Text);
      }
   }
